function cout=turn(lbx,fax,endsdx,viz,dim);
%global DIM;
%dim=DIM;
%new estimator of survival function lbx=last before
%fax=first after, endsdx=end of follow up;
%vis=matrix where each row is the patients visit history.
%code to find dimension;
after=((fax~=0) & (~isnan(lbx)));
lbx=lbx(after);
fax=fax(after);
endsdx=endsdx(after);
viz=viz(after,:);
n=length(lbx);
nvis=dim-1;
totdim=dim+2*nvis-1;
%initialization
nint=100;
likk=zeros(1,nint);

g=zeros(1,dim);
q=(1/dim)*ones(1,dim);
tmp=zeros(1,dim);
ctmp=tmp;
ovis=ones(1,nvis);
zvis=zeros(1,nvis);
pa=.5*ovis;pb=.5*ovis;
inf=zeros(dim+2*nvis-1,dim+2*nvis-1);
%Main Loop
last=0;
for i=1:nint
    g=zeros(1,dim);
    nb=zvis;
    mb=zvis;
    na=zvis;
    ma=zvis;
    lik=0;
    for l=1:n
        fa=fax(l);
        if fa>nvis
            fa=NaN;
        end
        
        lb=min(lbx(l),nvis);
        endsd=min(endsdx(l),nvis);
        %vi=viz(l,:);
        vi=viz(l,1:nvis);
        if fa-lb==1 
            dv=1:lb;
            da=fa:endsd;
            cont=q(fa)*prod(pb(dv).^vi(dv).*(1-pb(dv)).^(1-vi(dv)))*...
                       prod(pa(da).^vi(da).*(1-pa(da)).^(1-vi(da)));
            g(fa)=g(fa)+1;
            lik=lik+log(cont);
            nb(dv)=nb(dv)+vi(dv);
            mb(dv)=mb(dv)+1-vi(dv);
            na(da)=na(da)+vi(da);
            ma(da)=ma(da)+1-vi(da);

        else if fa==0
                da=1:endsd;
                cont=prod(pa(da).^vi(da).*(1-pa(da)).^(1-vi(da)));
                lik=lik+log(cont);
                na(da)=na(da)+vi(da);
                ma(da)=ma(da)+1-vi(da);

             else if  isnan(fa) 
                    db=(1:lb);
                    dv=((lb+1):dim);
                    for j=dv
                        db=1:min(j-1,endsd);
                        da=j:endsd;
                        tmp(j)=q(j)*...
                            prod(pb(db).^vi(db).*(1-pb(db)).^(1-vi(db)))*...
                            prod(pa(da).^vi(da).*(1-pa(da)).^(1-vi(da))); 
                    end
                    ss=sum(tmp(dv));
                    lik=lik+log(ss);
                    wt(dv)=tmp(dv)./ss;
                    g(dv)=g(dv)+wt(dv);
                    ds=((lb+1):endsd);            
                    cstmp(dv)=cumsum(tmp(dv));
                    iwb=[ones(1,lb) (ss-cstmp(ds))];
                    iwa=[zeros(1,lb) cstmp(ds)];
                    wa=iwa./(iwa+iwb);
                    wb=iwb./(iwa+iwb);
                    nb(1:endsd)=nb(1:endsd)+vi(1:endsd).*wb;
                    mb(1:endsd)=mb(1:endsd)+(1-vi(1:endsd)).*wb;
                    na(1:endsd)=na(1:endsd)+vi(1:endsd).*wa;
                    ma(1:endsd)=ma(1:endsd)+(1-vi(1:endsd)).*wa;
                else
                    db=(1:lb);
                    dv=((lb+1):fa);
                    for j=dv
                        db=1:j-1;
                        da=j:endsd;
                        tmp(j)=q(j)*...
                            prod(pb(db).^vi(db).*(1-pb(db)).^(1-vi(db)))*...
                            prod(pa(da).^vi(da).*(1-pa(da)).^(1-vi(da))); 
                        
                    end
                    ss=sum(tmp(dv));
                    lik=lik+log(ss);
                    wt(dv)=tmp(dv)./ss;
                    g(dv)=g(dv)+wt(dv);
                    
                    cstmp(dv)=cumsum(tmp(dv));
                    iwb=[ones(1,lb) (cstmp(fa)-cstmp(dv)) zeros(1,endsd-fa)];
                    iwa=[zeros(1,lb) cstmp(dv) ones(1,endsd-fa)];
                    wa=iwa./(iwa+iwb);
                    wb=iwb./(iwa+iwb);
                    nb(1:endsd)=nb(1:endsd)+vi(1:endsd).*wb;
                    mb(1:endsd)=mb(1:endsd)+(1-vi(1:endsd)).*wb;
                    na(1:endsd)=na(1:endsd)+vi(1:endsd).*wa;
                    ma(1:endsd)=ma(1:endsd)+(1-vi(1:endsd)).*wa;

                end
            end
        end
    end
    q=g/sum(g);
    ta=ma+na;
    ta(ta==0)=1;
    tb=mb+nb;
    tb(tb==0)=1;
    pa=na./ta;
    pb=nb./tb;
    likk(i)=lik;
    if last
        break
    end
end
cout=[q pa pb lik];